# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

from driverng.protocol.mllp import MLLPProtocol


class GlimsProtocol(MLLPProtocol):
    HL7_ACK = b"""MSH|^~\\&|%(sender_id)s||%(receiver_id)s||%(date)s||%(message_type)s|%(control_id)s|P|2.5|||||||\rMSA|AA|%(ack_id)s|Msg OK|||\r"""

    def get_ack_message(self, payload, date=None, control_id=None):
        splitted = payload.splitlines()[0].split(b"|")
        date = date or datetime.datetime.now()
        context = {
            b"date": date.strftime("%Y%m%d%H%M%S").encode(),
            b"control_id": splitted[9],
            b"sender_id": splitted[4],
            b"receiver_id": splitted[2],
            b"ack_id": splitted[9],
            b"message_type": b"ACK^R22",
        }
        return self.HL7_ACK % context
