# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "atellica_coag360_astm"


def test_order(self):
    message = self.order()
    expected = """
    H|\\^&|||MCA|||||||P|1
    P|1|036666666|||NYME^ANO|||F
    O|1||123456|^^^A|S|||||||||||PRESCRIBER|||||||||Q
    O|2||123456|^^^B|S||||||A|||||PRESCRIBER|||||||||Q
    L|1"""
    assert message == expected


def test_decode_control(self):
    worklist = self.decode(
        """
    H|\\^&|||ACOAG360^1.0^4711^H1P1O1R1C1Q1L1^1.0|||||||Q|1|20060221091239
    P|1||||^^|||
    O|1|ORKE502774|ORKE502774|^^^1^PT.sec.TS|||||||Q||||||||||||||X
    R|1|^^^1^PT.sec.TS^1:1^^F|14.244|sec||||F||||20060221091207
    C|1|I|ResultFlag 0|G
    L|1
    """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "control_lot": "ORKE502774",
                "results": [
                    {
                        "code": "1",
                        "date": datetime.datetime(2006, 2, 21, 9, 12, 7),
                        "dilution": "1:1",
                        "flags": ["ResultFlag 0"],
                        "value": "14.244",
                    }
                ],
                "sample_id": "ORKE502774",
                "type": "control",
            }
        ],
    }
    assert worklist == expected
