# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

from driverng import utils

parser_class = "filmarray"


@staticmethod
def unindent(self, data):
    data = "".join(
        [li.lstrip().replace("\t", "") for li in data.splitlines() if li.strip()]
    )
    return utils.prettify_xml(data.encode(self.F.ENCODING))


def test_decode_results(self):
    date = datetime.datetime(2017, 7, 14, 6, 54, 43)
    worklist = self.decode(
        """
    <aiMessage xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
        <header>
            <senderName>FilmArray</senderName>
            <processingIdentifier>P</processingIdentifier>
            <version>1394-97</version>
            <dateTime>20170714164931</dateTime>
            <messageType>FA_RESULTS</messageType>
        </header>
        <requestResult>
            <requestStatus>F</requestStatus>
            <testOrder>
                <specimen>
                    <specimenIdentifier>123456</specimenIdentifier>
                </specimen>
                <test>
                    <universalIdentifier>
                        <testIdentifier>GI</testIdentifier>
                        <testName>GI Panel</testName>
                        <testVersion>2.1</testVersion>
                    </universalIdentifier>
                    <instrumentType>FilmArray</instrumentType>
                    <instrumentSerialNumber>FA2583</instrumentSerialNumber>
                    <resultGroup>
                        <resultGroupCode>BACTER</resultGroupCode>
                        <resultGroupName>Bacteria</resultGroupName>
                        <resultGroupCodingSystem>BMX</resultGroupCodingSystem>
                        <result>
                            <resultID>
                                <resultTestCode>PCR_CLODIF_TAB</resultTestCode>
                                <resultTestName>Clostridium difficile toxin A/B</resultTestName>
                                <resultCodingSystem>BMX</resultCodingSystem>
                            </resultID>
                            <value>
                                <testResult>
                                    <valueType>CE</valueType>
                                    <observationValue>DETECT</observationValue>
                                    <observationName>Detected</observationName>
                                </testResult>
                            </value>
                            <operatorName>Bridget Turner</operatorName>
                            <resultDateTime>20170714065443</resultDateTime>
                        </result>
                        <result>
                            <resultID>
                                <resultTestCode>PCR_NEIMEN</resultTestCode>
                                <resultTestName>Neisseria meningitidis</resultTestName>
                                <resultCodingSystem>BMX</resultCodingSystem>
                            </resultID>
                            <value>
                                <testResult>
                                    <valueType>CE</valueType>
                                    <observationValue>DETECT</observationValue>
                                    <observationName>Detected</observationName>
                                </testResult>
                            </value>
                            <operatorName>Jane Doe (JaneDoe)</operatorName>
                            <resultDateTime>20170714065443</resultDateTime>
                        </result>
                    </resultGroup>
                    <disposableData>
                        <disposable>
                            <disposableIdentifier>01871278</disposableIdentifier>
                            <reference>GI Panel v2.1</reference>k$a
                            <disposableType>Pouch</disposableType>
                            <lotNumber>176714</lotNumber>
                        </disposable>
                    </disposableData>
                </test>
            </testOrder>
        </requestResult>
    </aiMessage>
    """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "results": [
                    {
                        "code": "PCR_CLODIF_TAB",
                        "value": "DETECT",
                        "date": date,
                        "lots": [{"lot": "176714", "type": "reagent"}],
                    },
                    {
                        "code": "PCR_NEIMEN",
                        "value": "DETECT",
                        "date": date,
                        "lots": [{"lot": "176714", "type": "reagent"}],
                    },
                ],
                "sample_id": "123456",
                "type": "patient",
            }
        ],
    }
    assert worklist == expected
