# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "illumipro"


def test_decode_result(self):
    worklist = self.decode(
        """
    Meridian Bioscience INC
    illumipro-10 Data Reader Results
    Serial Number: 3350

    Block,Assay,Day,Month,Year,Hour,Minute,Second,AssayName,AssayVersion,AssayCRC,SoftwareVersion,Sample ID1,Result1,Sample ID2,Result2,Sample ID3,Result3,Sample ID4,Result4,Sample ID5,Result5,
    BLOCK_A,1,6,3,17,14,50,14,C. difficile,B,16571,2.0.602,1703228401,NEG,1703209401,NEG,EMPTY WELL,EMPTY,EMPTY WELL,EMPTY,EMPTY WELL,EMPTY,
    BLOCK_A,1,10,3,17,8,21,45,C. difficile,B,16571,2.0.602,1703345201,POS,EMPTY WELL,EMPTY,EMPTY WELL,EMPTY,EMPTY WELL,EMPTY,EMPTY WELL,EMPTY,
    BLOCK_A,1,15,3,17,8,45,38,C. difficile,B,16571,2.0.602,36495,POS,EMPTY WELL,EMPTY,EMPTY WELL,EMPTY,EMPTY WELL,EMPTY,EMPTY WELL,EMPTY,
    """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "results": [
                    {
                        "code": "C. difficile",
                        "value": "NEG",
                        "date": datetime.datetime(2017, 3, 6, 14, 50, 14),
                    }
                ],
                "sample_id": "1703228401",
                "type": "patient",
            },
            {
                "results": [
                    {
                        "code": "C. difficile",
                        "value": "NEG",
                        "date": datetime.datetime(2017, 3, 6, 14, 50, 14),
                    }
                ],
                "sample_id": "1703209401",
                "type": "patient",
            },
            {
                "results": [
                    {
                        "code": "C. difficile",
                        "value": "POS",
                        "date": datetime.datetime(2017, 3, 10, 8, 21, 45),
                    }
                ],
                "sample_id": "1703345201",
                "type": "patient",
            },
            {
                "results": [
                    {
                        "code": "C. difficile",
                        "value": "POS",
                        "date": datetime.datetime(2017, 3, 15, 8, 45, 38),
                    }
                ],
                "sample_id": "36495",
                "type": "patient",
            },
        ],
    }
    assert worklist == expected
